/*----- PROTECTED REGION ID(Agilent4uhvClass.cpp) ENABLED START -----*/
static const char *TagName    = "Agilent4uhv $Name: release_06 $";
static const char *CvsPath    = "$Source: /home/cvsadm/cvsroot/fermi/servers/4uhv/src/Agilent4uhvClass.cpp,v $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        Agilent4uhvClass.cpp
//
// description : C++ source for the Agilent4uhvClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the Agilent4uhv once per process.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.3 $
// $Date: 2016-05-23 07:50:11 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Agilent4uhvClass.h>

/*----- PROTECTED REGION END -----*/	//	Agilent4uhvClass.cpp

//-------------------------------------------------------------------
/**
 *	Create Agilent4uhvClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_Agilent4uhv_class(const char *name) {
		return Agilent4uhv_ns::Agilent4uhvClass::init(name);
	}
}

namespace Agilent4uhv_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
Agilent4uhvClass *Agilent4uhvClass::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		Agilent4uhvClass::Agilent4uhvClass(string &s)
 * description : 	constructor for the Agilent4uhvClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
Agilent4uhvClass::Agilent4uhvClass(string &s):Serial2Client_ns::Serial2ClientClass(s)
{
	cout2 << "Entering Agilent4uhvClass constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(Agilent4uhvClass::constructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhvClass::constructor

	cout2 << "Leaving Agilent4uhvClass constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		Agilent4uhvClass::~Agilent4uhvClass()
 * description : 	destructor for the Agilent4uhvClass
 */
//--------------------------------------------------------
Agilent4uhvClass::~Agilent4uhvClass()
{
	/*----- PROTECTED REGION ID(Agilent4uhvClass::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhvClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		Agilent4uhvClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
Agilent4uhvClass *Agilent4uhvClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new Agilent4uhvClass(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		Agilent4uhvClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
Agilent4uhvClass *Agilent4uhvClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		OffHVXClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *OffHVXClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "OffHVXClass::execute(): arrived" << endl;
	((static_cast<Agilent4uhv *>(device))->off_hvx(*this));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		OnHVXClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *OnHVXClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "OnHVXClass::execute(): arrived" << endl;
	((static_cast<Agilent4uhv *>(device))->on_hvx(*this));
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : Agilent4uhvClass::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum Agilent4uhvClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : Agilent4uhvClass::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum Agilent4uhvClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : Agilent4uhvClass::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum Agilent4uhvClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : Agilent4uhvClass::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void Agilent4uhvClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "PollingSleep";
	prop_desc = "Sleep between hardware requests made by internal thread";
	prop_def  = "10000";
	vect_data.clear();
	vect_data.push_back("10000");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method      : Agilent4uhvClass::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void Agilent4uhvClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("");
	description << str_desc;
	data.push_back(description);

	//	put cvs or svn location
	string	filename("Agilent4uhv");
	filename += "Class.cpp";

	// check for cvs information
	string	src_path(CvsPath);
	start = src_path.find("/");
	if (start!=string::npos)
	{
		end   = src_path.find(filename);
		if (end>start)
		{
			string	strloc = src_path.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	// check for svn information
	else
	{
		string	src_path(SvnPath);
		start = src_path.find("://");
		if (start!=string::npos)
		{
			end = src_path.find(filename);
			if (end>start)
			{
				header = "$HeadURL: ";
				start = header.length();
				string	strloc = src_path.substr(start, (end-start));
				
				Tango::DbDatum	svn_loc("svn_location");
				svn_loc << strloc;
				data.push_back(svn_loc);
			}
		}
	}

	//	Get CVS or SVN revision tag
	
	// CVS tag
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}
	
	// SVN tag
	string	svnpath(SvnPath);
	header = "$HeadURL: ";
	start = header.length();
	
	end   = svnpath.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strloc = svnpath.substr(start, end-start);
		
		string tagstr ("/tags/");
		start = strloc.find(tagstr);
		if ( start!=string::npos )
		{
			start = start + tagstr.length();
			end   = strloc.find(filename);
			string	strtag = strloc.substr(start, end-start-1);
			
			Tango::DbDatum	svn_tag("svn_tag");
			svn_tag << strtag;
			data.push_back(svn_tag);
		}
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : Agilent4uhvClass::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void Agilent4uhvClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(Agilent4uhvClass::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhvClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new Agilent4uhv(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		Agilent4uhv *dev = static_cast<Agilent4uhv *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();
		dev->add_dynamic_commands();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(Agilent4uhvClass::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhvClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : Agilent4uhvClass::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void Agilent4uhvClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(Agilent4uhvClass::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhvClass::attribute_factory_before
	//	Call atribute_factory for inherited class
	Serial2Client_ns::Serial2ClientClass::attribute_factory(att_list);

	//	Attribute : Model
	ModelAttrib	*model = new ModelAttrib();
	Tango::UserDefaultAttrProp	model_prop;
	//	description	not set for Model
	//	label	not set for Model
	//	unit	not set for Model
	//	standard_unit	not set for Model
	//	display_unit	not set for Model
	//	format	not set for Model
	//	max_value	not set for Model
	//	min_value	not set for Model
	//	max_alarm	not set for Model
	//	min_alarm	not set for Model
	//	max_warning	not set for Model
	//	min_warning	not set for Model
	//	delta_t	not set for Model
	//	delta_val	not set for Model
	
	model->set_default_properties(model_prop);
	//	Not Polled
	model->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(model);

	//	Attribute : SerialNumber
	SerialNumberAttrib	*serialnumber = new SerialNumberAttrib();
	Tango::UserDefaultAttrProp	serialnumber_prop;
	//	description	not set for SerialNumber
	//	label	not set for SerialNumber
	//	unit	not set for SerialNumber
	//	standard_unit	not set for SerialNumber
	//	display_unit	not set for SerialNumber
	//	format	not set for SerialNumber
	//	max_value	not set for SerialNumber
	//	min_value	not set for SerialNumber
	//	max_alarm	not set for SerialNumber
	//	min_alarm	not set for SerialNumber
	//	max_warning	not set for SerialNumber
	//	min_warning	not set for SerialNumber
	//	delta_t	not set for SerialNumber
	//	delta_val	not set for SerialNumber
	
	serialnumber->set_default_properties(serialnumber_prop);
	//	Not Polled
	serialnumber->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(serialnumber);

	//	Attribute : TemperatureFan
	TemperatureFanAttrib	*temperaturefan = new TemperatureFanAttrib();
	Tango::UserDefaultAttrProp	temperaturefan_prop;
	//	description	not set for TemperatureFan
	//	label	not set for TemperatureFan
	temperaturefan_prop.set_unit("C");
	//	standard_unit	not set for TemperatureFan
	//	display_unit	not set for TemperatureFan
	//	format	not set for TemperatureFan
	temperaturefan_prop.set_max_value("200");
	temperaturefan_prop.set_min_value("0");
	//	max_alarm	not set for TemperatureFan
	//	min_alarm	not set for TemperatureFan
	//	max_warning	not set for TemperatureFan
	//	min_warning	not set for TemperatureFan
	//	delta_t	not set for TemperatureFan
	//	delta_val	not set for TemperatureFan
	
	temperaturefan->set_default_properties(temperaturefan_prop);
	//	Not Polled
	temperaturefan->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(temperaturefan);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(Agilent4uhvClass::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhvClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : Agilent4uhvClass::pipe_factory()
 *	Description : Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void Agilent4uhvClass::pipe_factory()
{
	/*----- PROTECTED REGION ID(Agilent4uhvClass::pipe_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhvClass::pipe_factory_before
	/*----- PROTECTED REGION ID(Agilent4uhvClass::pipe_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhvClass::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : Agilent4uhvClass::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void Agilent4uhvClass::command_factory()
{
	/*----- PROTECTED REGION ID(Agilent4uhvClass::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhvClass::command_factory_before
	//	Call command_factory for inherited class
	Serial2Client_ns::Serial2ClientClass::command_factory();



	/*----- PROTECTED REGION ID(Agilent4uhvClass::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhvClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		Agilent4uhvClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list
 */
//--------------------------------------------------------
void Agilent4uhvClass::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(Agilent4uhvClass::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhvClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		Agilent4uhvClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void Agilent4uhvClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		Agilent4uhv *dev = static_cast<Agilent4uhv *> (dev_impl);

		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(Agilent4uhvClass::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhvClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : Agilent4uhvClass::get_attr_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *Agilent4uhvClass::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(Agilent4uhvClass::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	Agilent4uhvClass::Additional Methods
} //	namespace
